<html lang="en">
<head>
<title>Expand Buttons - Speedbar: File/Tag summarizing utility</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Speedbar: File/Tag summarizing utility">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Creating-a-display.html#Creating-a-display" title="Creating a display">
<link rel="prev" href="Generic-Tag-Lists.html#Generic-Tag-Lists" title="Generic Tag Lists">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Expand-Buttons"></a>
Previous:&nbsp;<a rel="previous" accesskey="p" href="Generic-Tag-Lists.html#Generic-Tag-Lists">Generic Tag Lists</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Creating-a-display.html#Creating-a-display">Creating a display</a>
<hr>
</div>

<h4 class="subsection">7.4.3 Expand Buttons</h4>

<p>Once you have made some buttons, you need to hitch them up to
do something once clicked on.  This is set up with
<code>speedbar-make-tag-line</code> which takes two functions.  One is for
the expand button, and the other for the tag.

   <p>The function for the tag can be anything, but the expand button has
certain expectations.  When that button is has a <code>+</code> in it, that
indicates that there is &ldquo;more&rdquo; inside.  A <code>-</code> indicates that a
section can be closed.

   <p>The expand function takes the same signature as all speedbar button
functions, such as:

<pre class="example">     (defun MY-expand-function (text token indent)
        "Display more information about MY thing.
     ..."
</pre>
   <p>This function should then use the <var>text</var> parameter to determine
what to do.  For example:

<pre class="example">       (cond ((string-match "+" text)	;we have to expand this file
              ;; Expand stuff here
              )
     	((string-match "-" text)	;we have to contract this node
              ;; Contract stuff here
              ))
</pre>
   <p>When expanding or contracting, you will need to change the
<code>+</code> or <code>-</code> into the opposite symbol.  You can do that with

<div class="defun">
&mdash; Function: <b>speedbar-change-expand-button-char</b><var> char<a name="index-speedbar_002dchange_002dexpand_002dbutton_002dchar-89"></a></var><br>
<blockquote><p><a name="speedbar_002dchange_002dexpand_002dbutton_002dchar"></a>
Change the expansion button character to <var>char</var> for the current line. 
</p></blockquote></div>

   <p>Our sample would then look like this:

<pre class="example">       (cond ((string-match "+" text)	;we have to expand this file
              ;; Expand stuff here
     	 (speedbar-change-expand-button-char ?-)
              )
     	((string-match "-" text)	;we have to contract this node
              ;; Contract stuff here
     	 (speedbar-change-expand-button-char ?+)
              ))
</pre>
   <p>To expand text, the speedbar buffer needs to be writable.  The initial
button insertion function runs while the buffer is writable, but an
expand function will need to change that.  The best way is to use
<code>speedbar-with-writable</code>.

<div class="defun">
&mdash; Function: <b>speedbar-with-writable</b><var> &amp;rest forms<a name="index-speedbar_002dwith_002dwritable-90"></a></var><br>
<blockquote><p><a name="speedbar_002dwith_002dwritable"></a>
Allow the speedbar buffer to be writable and evaluate <var>forms</var>. 
</p></blockquote></div>

   <p>Once the buffer is writable, then you can insert more information
using any mechanism you like.  Remember that the cursor will be on the
expand button just clicked though.  As such, the code might look like
this:

<pre class="example">       (cond ((string-match "+" text)	;we have to expand this file
              ;; Expand stuff here
     	 (speedbar-change-expand-button-char ?-)
     	 (speedbar-with-writable
     	   (save-excursion
     	     (end-of-line) (forward-char 1)
                  ;; Insert goodies here.
                ))
              )
</pre>
   <p>Contracting a node is a bit easier.  You can just use this built in
function to do the work:

<div class="defun">
&mdash; Function: <b>speedbar-delete-subblock</b><var> indent<a name="index-speedbar_002ddelete_002dsubblock-91"></a></var><br>
<blockquote><p><a name="speedbar_002ddelete_002dsubblock"></a>
Delete text from point to indentation level <var>indent</var> or greater. 
Handles end-of-sublist smartly.

        <p>Remember that <var>indent</var> is also available as passed into
<code>MY-expand-function</code>. 
</p></blockquote></div>

   <p>The end result would then look like this:

<pre class="example">       (cond ((string-match "+" text)	;we have to expand this file
              ;; Expand stuff here
     	 (speedbar-change-expand-button-char ?-)
     	 (speedbar-with-writable
     	   (save-excursion
     	     (end-of-line) (forward-char 1)
                  ;; Insert goodies here.
                ))
              )
     	((string-match "-" text)	;we have to contract this node
              ;; Contract stuff here
     	 (speedbar-change-expand-button-char ?+)
     	 (speedbar-delete-subblock indent))
              ))
</pre>
   <p>Expand buttons, unlike other speedbar operations can cause new data to
appear in speedbar which would be useful to force onto the screen. 
You can then recenter using this function:

<div class="defun">
&mdash; Function: <b>speedbar-center-buffer-smartly</b><var><a name="index-speedbar_002dcenter_002dbuffer_002dsmartly-92"></a></var><br>
<blockquote><p><a name="speedbar_002dcenter_002dbuffer_002dsmartly"></a>
Recenter a speedbar buffer so the current indentation level is all visible. 
This assumes that the cursor is on a file, or tag of a file which the user is
interested in. 
</p></blockquote></div>

   </body></html>

